k_rem_pio2.c File Reference
`#include "math_libm.h"`
`#include "math_private.h"`
`#include "SDL_assert.h"`
Include dependency graph for k_rem_pio2.c:

Go to the source code of this file.

## Functions

| libm_hidden_proto (scalbn)
int attribute_hidden | __kernel_rem_pio2 (x, y, int e0, int nx, int prec, ipio2)

## Variables

static double | PIo2 []
static double | zero = 0.0
static double | one = 1.0
static double | two24 = 1.67772160000000000000e+07
static double | twon24 = 5.96046447753906250000e-08

## Function Documentation

int attribute_hidden __kernel_rem_pio2 | ( | x | ,
|  | y | ,
|  | int | e0,
|  | int | nx,
|  | int | prec,
|  | ipio2 |
| ) |  |

Definition at line 176 of file k_rem_pio2.c.

References floor, i, j, one, scalbn, SDL_arraysize, SDL_assert, two24, twon24, and zero.

Referenced by __ieee754_rem_pio2().

{
int32_t jz, jx, jv, jp, jk, carry, n, iq[20], i, j, k, m, q0, ih;
double z, fw, f[20], fq[20], q[20];
/* initialize jk */
SDL_assert((prec >= 0) && (prec < SDL_arraysize(init_jk)));
jk = init_jk[prec];
SDL_assert((jk >= 2) && (jk <= 6));
jp = jk;
/* determine jx,jv,q0, note that 3>q0 */
SDL_assert(nx > 0);
jx = nx - 1;
jv = (e0 - 3) / 24;
if (jv < 0)
jv = 0;
q0 = e0 - 24 * (jv + 1);
/* set up f[0] to f[jx+jk] where f[jx+jk] = ipio2[jv+jk] */
j = jv - jx;
m = jx + jk;
for (i = 0; i <= m; i++, j++)
f[i] = (j < 0) ? zero : (double) ipio2[j];
/* compute q[0],q[1],...q[jk] */
for (i = 0; i <= jk; i++) {
for (j = 0, fw = 0.0; j <= jx; j++)
fw += x[j] * f[jx + i - j];
q[i] = fw;
}
jz = jk;
recompute:
/* distill q[] into iq[] reversingly */
for (i = 0, j = jz, z = q[jz]; j > 0; i++, j--) {
fw = (double) ((int32_t) (twon24 * z));
iq[i] = (int32_t) (z - two24 * fw);
z = q[j - 1] + fw;
}
/* compute n */
z = scalbn(z, q0); /* actual value of z */
z -= 8.0 * floor(z * 0.125); /* trim off integer >= 8 */
n = (int32_t) z;
z -= (double) n;
ih = 0;
if (q0 > 0) { /* need iq[jz-1] to determine n */
i = (iq[jz - 1] >> (24 - q0));
n += i;
iq[jz - 1] -= i << (24 - q0);
ih = iq[jz - 1] >> (23 - q0);
} else if (q0 == 0)
ih = iq[jz - 1] >> 23;
else if (z >= 0.5)
ih = 2;
if (ih > 0) { /* q > 0.5 */
n += 1;
carry = 0;
for (i = 0; i < jz; i++) { /* compute 1-q */
j = iq[i];
if (carry == 0) {
if (j != 0) {
carry = 1;
iq[i] = 0x1000000 - j;
}
} else
iq[i] = 0xffffff - j;
}
if (q0 > 0) { /* rare case: chance is 1 in 12 */
switch (q0) {
case 1:
iq[jz - 1] &= 0x7fffff;
break;
case 2:
iq[jz - 1] &= 0x3fffff;
break;
}
}
if (ih == 2) {
z = one - z;
if (carry != 0)
z -= scalbn(one, q0);
}
}
/* check if recomputation is needed */
if (z == zero) {
j = 0;
for (i = jz - 1; i >= jk; i--)
j |= iq[i];
if (j == 0) { /* need recomputation */
for (k = 1; iq[jk - k] == 0; k++); /* k = no. of terms needed */
for (i = jz + 1; i <= jz + k; i++) { /* add q[jz+1] to q[jz+k] */
f[jx + i] = (double) ipio2[jv + i];
for (j = 0, fw = 0.0; j <= jx; j++)
fw += x[j] * f[jx + i - j];
q[i] = fw;
}
jz += k;
goto recompute;
}
}
/* chop off zero terms */
if (z == 0.0) {
jz -= 1;
q0 -= 24;
while (iq[jz] == 0) {
jz--;
q0 -= 24;
}
} else { /* break z into 24-bit if necessary */
z = scalbn(z, -q0);
if (z >= two24) {
fw = (double) ((int32_t) (twon24 * z));
iq[jz] = (int32_t) (z - two24 * fw);
jz += 1;
q0 += 24;
iq[jz] = (int32_t) fw;
} else
iq[jz] = (int32_t) z;
}
/* convert integer "bit" chunk to floating-point value */
fw = scalbn(one, q0);
for (i = jz; i >= 0; i--) {
q[i] = fw * (double) iq[i];
fw *= twon24;
}
/* compute PIo2[0,...,jp]*q[jz,...,0] */
for (i = jz; i >= 0; i--) {
for (fw = 0.0, k = 0; k <= jp && k <= jz - i; k++)
fw += PIo2[k] * q[i + k];
fq[jz - i] = fw;
}
/* compress fq[] into y[] */
switch (prec) {
case 0:
fw = 0.0;
for (i = jz; i >= 0; i--)
fw += fq[i];
y[0] = (ih == 0) ? fw : -fw;
break;
case 1:
case 2:
fw = 0.0;
for (i = jz; i >= 0; i--)
fw += fq[i];
y[0] = (ih == 0) ? fw : -fw;
fw = fq[0] - fw;
for (i = 1; i <= jz; i++)
fw += fq[i];
y[1] = (ih == 0) ? fw : -fw;
break;
case 3: /* painful */
for (i = jz; i > 0; i--) {
fw = fq[i - 1] + fq[i];
fq[i] += fq[i - 1] - fw;
fq[i - 1] = fw;
}
for (i = jz; i > 1; i--) {
fw = fq[i - 1] + fq[i];
fq[i] += fq[i - 1] - fw;
fq[i - 1] = fw;
}
for (fw = 0.0, i = jz; i >= 2; i--)
fw += fq[i];
if (ih == 0) {
y[0] = fq[0];
y[1] = fq[1];
y[2] = fw;
} else {
y[0] = -fq[0];
y[1] = -fq[1];
y[2] = -fw;
}
}
return n & 7;
}
PIo2
static double PIo2[]
Definition: k_rem_pio2.c:150
n
GLdouble n
Definition: SDL_opengl_glext.h:1952
int32_t
signed int int32_t
Definition: SDL_config_windows.h:61
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
q
GLdouble GLdouble GLdouble GLdouble q
Definition: SDL_opengl.h:2080
m
const GLfloat * m
Definition: SDL_opengl_glext.h:6092
f
GLfloat f
Definition: SDL_opengl_glext.h:1870
one
static double one
Definition: k_rem_pio2.c:167
scalbn
#define scalbn
Definition: math_private.h:40
two24
static double two24
Definition: k_rem_pio2.c:167
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
nx
GLbyte nx
Definition: SDL_opengl_glext.h:5713
twon24
static double twon24
Definition: k_rem_pio2.c:168
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
SDL_assert
#define SDL_assert(condition)
Definition: SDL_assert.h:167
z
GLdouble GLdouble z
Definition: SDL_opengl_glext.h:404
zero
static double zero
Definition: k_rem_pio2.c:167
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:93
floor
#define floor
Definition: math_private.h:37
j
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int int in j)
Definition: SDL_x11sym.h:42

libm_hidden_proto | ( | scalbn |  | ) |

Definition at line 139 of file k_rem_pio2.c.

References PIo2.

{ 2, 3, 4, 6 }; /* initial value for jk */
#else
static int init_jk[] = { 2, 3, 4, 6 };

## Variable Documentation

double one = 1.0

static

Definition at line 167 of file k_rem_pio2.c.

Referenced by __kernel_rem_pio2().

double PIo2[]

static

Initial value:
= {
1.57079625129699707031e+00,
7.54978941586159635335e-08,
5.39030252995776476554e-15,
3.28200341580791294123e-22,
1.27065575308067607349e-29,
1.22933308981111328932e-36,
2.73370053816464559624e-44,
2.16741683877804819444e-51,
}

Definition at line 150 of file k_rem_pio2.c.

Referenced by libm_hidden_proto().

double two24 = 1.67772160000000000000e+07

static

Definition at line 167 of file k_rem_pio2.c.

Referenced by __kernel_rem_pio2().

double twon24 = 5.96046447753906250000e-08

static

Definition at line 168 of file k_rem_pio2.c.

Referenced by __kernel_rem_pio2().

double zero = 0.0

static

Definition at line 167 of file k_rem_pio2.c.

Referenced by __kernel_rem_pio2().